pastebin - collaborative debugging tool
rovema.kpaste.net RSS


msnfs41client: Patch for tests using native Windows tar.exe, 2024-11-13
Posted by Anonymous on Wed 13th Nov 2024 17:35
raw | new post

  1. From 8b3408639e65914aca9f780db765b5eb14162e1b Mon Sep 17 00:00:00 2001
  2. From: Roland Mainz <roland.mainz@nrubsig.org>
  3. Date: Wed, 13 Nov 2024 18:12:19 +0100
  4. Subject: [PATCH] cygwin,tests: Add tests for Windows native tar
  5.  
  6. Add tests for Windows native tar (/cygdrive/c/Windows/system32/tar.exe)
  7.  
  8. Signed-off-by: Cedric Blancher <cedric.blancher@gmail.com>
  9. ---
  10. cygwin/Makefile.install                       |  2 +
  11.  tests/manual_testing.txt                      | 10 +++
  12.  .../wintartest_comparewinvsgnu001.bash        | 77 +++++++++++++++++++
  13.  tests/wintartests/wintartest_seq001.bash      | 51 ++++++++++++
  14.  4 files changed, 140 insertions(+)
  15.  create mode 100644 tests/wintartests/wintartest_comparewinvsgnu001.bash
  16.  create mode 100644 tests/wintartests/wintartest_seq001.bash
  17.  
  18. diff --git a/cygwin/Makefile.install b/cygwin/Makefile.install
  19. index 438475b..019f038 100644
  20. --- a/cygwin/Makefile.install
  21. +++ b/cygwin/Makefile.install
  22. @@ -96,6 +96,8 @@ installdest:
  23.         fi
  24.         cp $(PROJECT_BASEDIR_DIR)/tests/nfsbuildtest/nfsbuildtest.ksh93 $(DESTDIR)/$(CYGWIN_BASEPATH)/usr/share/msnfs41client/tests/misc/nfsbuildtest.ksh93
  25.         cp $(PROJECT_BASEDIR_DIR)/tests/fstest_make_numtree1/fstest_make_numtree1.ksh93 $(DESTDIR)/$(CYGWIN_BASEPATH)/usr/share/msnfs41client/tests/misc/fstest_make_numtree1.ksh93
  26. +       cp $(PROJECT_BASEDIR_DIR)/tests/wintartests/wintartest_comparewinvsgnu001.bash $(DESTDIR)/$(CYGWIN_BASEPATH)/usr/share/msnfs41client/tests/misc/wintartest_comparewinvsgnu001.bash
  27. +       cp $(PROJECT_BASEDIR_DIR)/tests/wintartests/wintartest_seq001.bash $(DESTDIR)/$(CYGWIN_BASEPATH)/usr/share/msnfs41client/tests/misc/wintartest_seq001.bash
  28.         @ printf "# Package ksh93&co (if available) since Cygwin does not ship with it yet\n"
  29.         [[ -x $(CYGWIN_BASEPATH)/bin/ksh93.exe ]] && cp -f $(CYGWIN_BASEPATH)/bin/ksh93.exe $(DESTDIR)/$(CYGWIN_BASEPATH)/bin/ksh93.exe || true
  30.         [[ -x $(CYGWIN_BASEPATH)/bin/shcomp.exe ]] && cp -f $(CYGWIN_BASEPATH)/bin/shcomp.exe $(DESTDIR)/$(CYGWIN_BASEPATH)/bin/shcomp.exe || true
  31. diff --git a/tests/manual_testing.txt b/tests/manual_testing.txt
  32. index 65848c8..8ba983c 100644
  33. --- a/tests/manual_testing.txt
  34. +++ b/tests/manual_testing.txt
  35. @@ -411,5 +411,15 @@ time ksh93 $msnfs41clientgitroot/tests/fstest_make_numtree1/fstest_make_numtree1
  36.  cd /cygdrive/n/xxx/
  37.  drmemory -batch -check_uninit_all -strict_bitops -logdir "$(cygpath -w "$PWD")" -- "$(cygpath -w /sbin/nfs_mount)"
  38.  
  39. +#
  40. +# Run Windows tar (/cygdrive/c/Windows/system32/tar) tests
  41. +# on NFSv4.1 filesystem
  42. +#
  43. +
  44. +cd /cygdrive/n/xxx/
  45. +bash /usr/share/msnfs41client/tests/misc/wintartests/wintartest_seq001.bash
  46. +
  47. +cd /cygdrive/n/xxx/
  48. +bash /usr/share/msnfs41client/tests/misc/wintartest_comparewinvsgnu001.bash mytarfile.tar.bz2
  49.  
  50.  # EOF.
  51. diff --git a/tests/wintartests/wintartest_comparewinvsgnu001.bash b/tests/wintartests/wintartest_comparewinvsgnu001.bash
  52. new file mode 100644
  53. index 0000000..39c1ffb
  54. --- /dev/null
  55. +++ b/tests/wintartests/wintartest_comparewinvsgnu001.bash
  56. @@ -0,0 +1,77 @@
  57. +#!/bin/bash
  58. +
  59. +#
  60. +# wintartest_comparewinvsgnu001.bash - filesystem test
  61. +# which compares files unpacked by /cygdrive/c/Windows/system32/tar
  62. +# and /usr/bin/tar, and checks whether files have same hashes
  63. +#
  64. +# Written by Roland Mainz <roland.mainz@nrubsig.org>
  65. +#
  66. +
  67. +#
  68. +# Notes:
  69. +# - Genreate test tar.bz2 files like this:
  70. +# $ seq 1000000 >10000seq.txt ; tar -cvf - 10000seq.txt | bzip2 -9 >10000seq.tar.bz2
  71. +# - Compare individual files with
  72. +# $ diff -u <(od -x -v cygwintar/bin/ksh93.exe) <(od -x -v wintar/bin/ksh93.exe)
  73. +#
  74. +
  75. +export PATH='/bin:/usr/bin'
  76. +
  77. +# set umask=0000 to avoid permission madness on SMB
  78. +umask 0000
  79. +
  80. +typeset intarfile="$1"
  81. +typeset f
  82. +typeset -i num_failed_hash_compare=0
  83. +
  84. +if [[ ! -x '/cygdrive/c/Windows/system32/tar' ]] ; then
  85. +       printf $"%s: %s not found.\n" \
  86. +               "$0" '/cygdrive/c/Windows/system32/tar' 1>&2
  87. +       exit 1
  88. +fi
  89. +
  90. +if [[ ! -r "$intarfile" ]] ; then
  91. +       printf $"%s: Input file %q not readable.\n" \
  92. +               "$0" "$intarfile" 1>&2
  93. +       exit 1
  94. +fi
  95. +
  96. +typeset IFS=$'\n'
  97. +
  98. +set -o xtrace
  99. +set -o errexit
  100. +
  101. +intarfile="$(realpath "$intarfile")"
  102. +
  103. +rm -Rf 'wintar_tmp' 'cygwintar_tmp'
  104. +mkdir 'wintar_tmp' 'cygwintar_tmp'
  105. +
  106. +cd 'wintar_tmp'
  107. +/cygdrive/c/Windows/system32/tar -xvf "$(cygpath -w "$intarfile")"
  108. +cd '..'
  109. +
  110. +cd 'cygwintar_tmp'
  111. +/usr/bin/tar -xvf "$intarfile"
  112. +cd '..'
  113. +
  114. +typeset -a file_list=(
  115. +       $(cd 'cygwintar_tmp' && find . -type f)
  116. +)
  117. +
  118. +set +o xtrace +o errexit
  119. +
  120. +for f in "${file_list[@]}" ; do
  121. +       IFS=' ' read wintar_hash dummy < <(openssl md5 -r "wintar_tmp/$f")
  122. +       IFS=' ' read cygwintar_hash dummy < <(openssl md5 -r "cygwintar_tmp/$f")
  123. +
  124. +       if [[ "$wintar_hash" == "$cygwintar_hash" ]] ; then
  125. +               printf $"NOTE:\tHashes for file %q OK\n" "$f"
  126. +       else
  127. +               printf $"ERROR:\tHashes for file %q differ, wintar_hash(%s) != cygwintar_hash(%s)\n" \
  128. +                       "$f" "$wintar_hash" "$cygwintar_hash"
  129. +               (( num_failed_hash_compare++ ))
  130. +       fi
  131. +done
  132. +
  133. +exit $((num_failed_hash_compare > 0?1:0))
  134. diff --git a/tests/wintartests/wintartest_seq001.bash b/tests/wintartests/wintartest_seq001.bash
  135. new file mode 100644
  136. index 0000000..489d169
  137. --- /dev/null
  138. +++ b/tests/wintartests/wintartest_seq001.bash
  139. @@ -0,0 +1,51 @@
  140. +#!/bin/bash
  141. +
  142. +#
  143. +# wintartest_seq001.bash - filesystem test
  144. +# which generates files with /usr/bin/seq, packs them with
  145. +# Cygwin's GNU /usr/bin/tar and tests whether they contain
  146. +# zero-bytes (which should never appear in a text file)
  147. +# after unpacking them
  148. +# with /cygdrive/c/Windows/system32/tar
  149. +#
  150. +# Written by Roland Mainz <roland.mainz@nrubsig.org>
  151. +#
  152. +
  153. +export PATH='/bin:/usr/bin'
  154. +
  155. +typeset -i i
  156. +typeset out
  157. +
  158. +set -o xtrace
  159. +set -o errexit
  160. +
  161. +# Set umask=0000 to avoid permission trouble with SMB filesystems
  162. +umask 0000
  163. +
  164. +rm -f '10000seq.txt'
  165. +seq 100000 >'10000seq.txt' ; tar -cvf - '10000seq.txt' >'10000seq.tar' #| pbzip2 -1 >'10000seq.tar.bz2'
  166. +
  167. +rm -Rf 'tmp'
  168. +mkdir 'tmp'
  169. +cd 'tmp'
  170. +
  171. +set +o xtrace
  172. +
  173. +for (( i=0 ; i < 2000 ; i++ )) ; do
  174. +       printf '# Cycle %d:\n' "$i"
  175. +       /cygdrive/c/Windows/system32/tar -xvf "$(cygpath -w '../10000seq.tar')"
  176. +       out="$(od -x -v '10000seq.txt' | grep -F ' 0000' | head -n 5)"
  177. +
  178. +       if [[ "$out" != '' ]] ; then
  179. +               printf '# ERROR: Sequence of zero bytes in plain /usr/bin/seq output found:\n'
  180. +               printf -- '---- snip ----\n%s\n---- snip ----\n' "$out"
  181. +               exit 1
  182. +       fi
  183. +
  184. +       rm -f '10000seq.txt'
  185. +done
  186. +
  187. +printf '# SUCCESS\n'
  188. +
  189. +exit 0
  190. +# EOF.
  191. --
  192. 2.45.1

Submit a correction or amendment below (click here to make a fresh posting)
After submitting an amendment, you'll be able to view the differences between the old and new posts easily.

Syntax highlighting:

To highlight particular lines, prefix each line with {%HIGHLIGHT}




All content is user-submitted.
The administrators of this site (kpaste.net) are not responsible for their content.
Abuse reports should be emailed to us at